use32

	       org    0x0

	       db     'MENUET01'	      ; 8 byte id
	       dd     0x01		      ; header version
	       dd     START		      ; start of code
	       dd     I_END		      ; size of image
	       dd     I_END+0x200000		    ; memory for app
	       dd     0x7fff0		      ; esp
	       dd     currentp,0x0	  ; I_Param , I_Icon


maxmenus equ 8
maxprogs equ 20
include 'meos.inc'
include 'tparser.inc'

START:


 loadcfgfile
 parse
 call calc_size
 call draw_window

still:

    mov  eax,10 		; wait here for event
    int  0x40

    cmp  eax,1			; redraw request ?
    je	 red
    cmp  eax,2			; key in buffer ?
    je	 key
    cmp  eax,3			; button in buffer ?
    je	 button

    jmp  still

  red:				; redraw
    call draw_window
    jmp  still

  key:				; key
    mov  eax,2			; just read it and ignore
    int  0x40
    cmp ah,27
    je	endapp
    jmp  still
 ;
  button:			; button
    mov  eax,17 		; get id
    int  0x40
    shr eax,8
    mov [cpt],eax
    getprogaddr dword [currentp],[cpt],mprogramm,edx
    add edx,60


    mov [fileinfo.subfunct],0x7
    mov [fileinfo.bytes],   0x0
    mov [fileinfo.buffer],  0x0
    mov [fileinfo.ptrpath], edx
    mov eax,70
    mov ebx,fileinfo
    int 0x40
    endapp:
    mov eax,-1
    int 0x40
jmp  still

;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:
 _meos_begin_window_redraw
 _meos_draw_window [txstart],[txsize],[tystart],[tysize],0x01ffffff,0x01ffffff,0x0

 call draw_btn
 _meos_end_window_redraw
ret

draw_btn:
  mov [tx1],0
  mov eax,[txsize]
  mov [tx2],eax
  mov [ty2],30

  mov [cpt],1

.forcpt:
  mov ecx,[cpt]
  getnbrmenu dword [currentp],nbrmenuprogs,eax
  cmp ecx,eax
  ja  .endcpt
    mov ecx,[cpt]
    dec ecx
    imul ecx,30
    mov [ty1],ecx

    _meos_define_button [tx1],[tx2],[ty1],[ty2],[cpt],[tcolor1]

    mov ecx,100
    xor esi,esi

    getprogaddr dword [currentp],[cpt],mprogramm,edx
    mov eax,4
    mov ebx,[tx1]
    add ebx,12
    shl ebx,16
    add ebx,[ty1]
    add ebx, 10
    mov ecx,0x90000000
    add ecx,[tcolor2]
    int 0x40
   inc [cpt]
   jmp .forcpt
  .endcpt:
ret


calc_size:
	mov eax,61
	mov ebx,1
	int 0x40
	xor ebx,ebx
	xor ecx,ecx
	mov cx,ax
	shr eax,16
	mov bx,ax
	sub ebx,420
	shr ebx,1
	mov [x_pos],ebx
	sub ecx,61
	mov [y_pos],ecx

	getnbrmenu dword [currentp],nbrmenuprogs,eax
	cmp eax,0
	jna endapp
	imul eax,30
	mov [tysize],eax
	mov ebx,[y_pos]
	sub ebx,eax
	mov [tystart],ebx

	mov eax,dword [currentp]
	dec eax
	imul eax,40
	add eax,10
	add eax,[x_pos]
	mov [txstart],eax
	cmp dword [currentp],4
	jna .suite
		add dword [txstart],80
	.suite:
ret

cpt dd 0
tx1	dd 0
ty1	dd 0
tx2	dd 0
ty2	dd 0
tx3	dd 0
ty3	dd 0
txstart dd 0
txsize	dd 130
tystart dd 0
tysize	dd 0
tcolor1 dd 0xeeeeee
tcolor2 dd 0
tcolor3 dd 0
x_pos dd 0x0
y_pos dd 0x0

currentp : rb 6

  nbrmenuprogs : times(maxmenus) dd 0x0
  mprogramm    : times(maxmenus*maxprogs) dd 0x0
cfgfile   : db '/rd/1/menuini.dat',0



cfg:

I_END: