macro _meos_draw_string xstart,ystart,str_begin,str_len,color
{
  mov eax,4
  mov ebx,xstart
  shl ebx,16
  add ebx,ystart
  mov ecx,color
  mov edx,str_begin
  mov esi,str_len
  int 0x40
}

macro _meos_draw_rectangle xstart,xsize,ystart,ysize,color
{
 mov eax,13
 mov ebx,xstart
 shl ebx,16
 add ebx,xsize
 mov ecx,ystart
 shl ecx,16
 add ecx,ysize
 mov edx,color
 int 0x40
}


macro _meos_draw_window xstart,xsize,ystart,ysize,workarea,header,frame
{
  mov eax,0
  mov ebx,xstart
  shl ebx,16
  add ebx,xsize
  mov ecx,ystart
  shl ecx,16
  add ecx,ysize
  mov edx,workarea
  mov esi,header
  mov edi,frame
  int 0x40
}

macro _meos_get_key
{
  mov eax,2
  int 0x40
}

macro _meos_define_button xstart,xsize,ystart,ysize,id,color
{
  mov eax,8
  mov ebx,xstart
  shl ebx,16
  add ebx,xsize
  mov ecx,ystart
  shl ecx,16
  add ecx,ysize
  mov edx,id
  mov esi,color
  int 0x40
}

macro _meos_wait_for_event
{
   mov eax,10
   int 0x40
}

macro _meos_get_pressed_button
{
   mov eax,17
   int 0x40
}

macro _meos_begin_window_redraw
{
  mov eax,12
  mov ebx,1
  int 0x40
}

macro _meos_end_window_redraw
{
  mov eax,12
  mov ebx,2
  int 0x40
}


macro _meos_draw_line xstart,ystart,xend,yend,color
{
  mov eax,38
  mov ebx,xstart
  shl ebx,16
  add ebx,xend
  mov ecx,ystart
  shl ecx,16
  add ecx,yend
  mov edx,color
  int 0x40
}

macro draw_troisd x1,y1,x2,y2,color1,color2,color3
{
  _meos_draw_rectangle x1,x2,y1,y2,color1
  _meos_draw_line x1,y1,x2,y1,color2
  _meos_draw_line x1,y1,x1,y2,color2
  _meos_draw_line x2,y1,x2,y2,color3
  _meos_draw_line x1,y2,x2,y2,color3
}