;
;   Modele d'application vierge
;

use32

	       org    0x0

	       db     'MENUET01'	      ; 8 byte id
	       dd     0x01		      ; header version
	       dd     START		      ; start of code
	       dd     I_END		      ; size of image
	       dd     0x200000		      ; memory for app
	       dd     0x7fff0		      ; esp
	       dd     0x0 , 0x0 	      ; I_Param , I_Icon


include 'taskbar.inc'


START:				; start of execution
     call calc_size
     call update_proc_list

still:
    call update_proc_list
    mov  eax,23
    mov ebx,20		    ; wait here for event
    int  0x40

    cmp  eax,1			; redraw request ?
    je	 red
    cmp  eax,2			; key in buffer ?
    je	 key
    cmp  eax,3			; button in buffer ?
    je	 button

jmp  still

  red:				; redraw
    call draw_window
    jmp  still

  key:				; key
    mov  eax,2			; just read it and ignore
    int  0x40
    jmp  still

  button:			; button
    mov eax,17
    int 0x40
    shr eax,8			;on a le numero du bouton activ

    cmp eax,1
    jne no1
     cmp [first],0
     jna still
     dec [first]
     call update_proc_list
     call draw_window
     jmp still
    no1:

   cmp eax,2
    jne no2
    inc [first]
    call update_proc_list
    call draw_window
    jmp still

    no2:
    sub eax,3
    imul eax,16 		;on calcule la position du numero
    mov ecx,dword [processes+eax]     ;de programme correspondat
    mov eax,18
    mov ebx,3			;on active la fenetre
    int 0x40
    jmp still

jmp  still




;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:
 _meos_begin_window_redraw
 _meos_draw_window [xstart],[xsize],[ystart],[ysize],0x01ffffff,0x01ffffff,0x0
 _meos_draw_rectangle 0,[xsize],0,21,0x00dddddd

 mov eax,[xsize]
 sub eax,20
 mov [cpt],eax
 _meos_define_button 0	  ,20,0,20,1,0x00dddddd
 _meos_define_button [cpt],20,0,20,2,0x00dddddd
 mov eax,4
 mov ebx,7
 shl ebx,16
 add ebx,7
 mov ecx,0x10000000
 mov edx,f1
 mov esi,1
 int 0x40

 mov eax,4
 mov ebx,[cpt]
 add ebx,7
 shl ebx,16
 add ebx,7
 mov edx,f2
 int 0x40

 mov ecx,1
 drwbtn:
 cmp ecx,[nbrbtn]
 ja  end_drwbtn
     ;On dessine chaque bouton
     mov [btnid],ecx
     dec ecx
     imul ecx,[btnxsize]
     add ecx,20
     add ecx,[firstpos]
     mov [btnxpos],ecx
     add [btnid],2
     _meos_define_button [btnxpos],[btnxsize],[btnypos],[btnysize],[btnid],0x00dddddd
     sub [btnid],2
     ;On dessine chaque texte
     mov eax,4
     mov ebx,[btnxpos]
     add ebx,10
     shl ebx,16
     add ebx,7
     mov ecx,0x10000000
     mov edx,[btnid]
     dec edx
     imul edx,16
     add edx,4
     add edx,processes
     mov esi,12
     int 0x40
  mov ecx,[btnid]
  inc ecx
  jmp drwbtn

  end_drwbtn:
 _meos_end_window_redraw
ret


calc_size:
  ;on demande la taille de l'ecran
  mov eax,61
  mov ebx,1
  int 0x40
  ;on calcule la largeur de l'ecran qui correspond a la largeur
  ;de la fenetre
  mov ebx,eax
  shr eax,16
  mov [xsize],eax

  mov [ystart],0

  ;on calcule le nombre de boutons
  mov ebx,[btnxsize]
  mov eax,[xsize]
  sub eax,40
  div ebx
  cbw
  mov [nbrbtn],eax

  imul eax,[btnxsize]
  mov ebx,[xsize]
  sub ebx,eax
  shr ebx,2
  mov [firstpos],ebx
ret

update_proc_list:

  call clear_proc_list
  ;On recherche le nombre de programmes
  mov eax,9
  mov ebx,process_table
  mov ecx,-1
  int 0x40
  mov [nbrproc],eax   ; pas de changements



  ;On dmare la boucle
  mov [cpt2],0
  mov [cpt1],0
  mov [cpt],1
 .for:
  mov ecx,[nbrproc]
  cmp [cpt],ecx
  ja .next
    ;On lis les info d'un prog
    mov eax,9
    mov ebx,process_table
    mov ecx,[cpt]
    int 0x40

    ;on verifie que ce n'est pas un de ceux ci
    cmp byte [process_table+10],'@'
    jz .suite
    cmp word [process_table+10] ,'OS'
    jz .suite
    cmp word [process_table+10] ,'  '
    jz .suite
    cmp dword [process_table+10] ,'ICON'
    jz .suite

    ;On copie le numero dans la liste
    mov eax,[first]
    cmp [cpt1],eax
    jb .suite


    mov ebx,[cpt]
    mov eax,[cpt2]
    imul eax,16
    mov [processes+eax],ebx

    ;On copie le nom dans la table
    add eax,4
    mov edi,eax
    add edi,processes

    mov esi,process_table
    add esi,10
    mov ecx,12
    cld
    rep movsb


    inc [cpt2]
    mov ecx,[nbrbtn]
    cmp [cpt2],ecx
    ja .next
  .suite:
  inc [cpt1]
  inc [cpt]
  jmp .for
 .next:


  mov eax,[cpt2]
  cmp eax,[run_app]
  je .suite_update

  call draw_window
  mov eax,[cpt2]
  mov [run_app],eax

  .suite_update:
ret

clear_proc_list:

 mov ecx,[nbrbtn]
 clear_list:
    mov [cpt1],ecx
    ;On copie le numero dans la liste
    mov eax,[cpt1]
    dec eax
    imul eax,16
    mov [processes+eax],dword 0

    ;On copie le nom dans la table
    add eax,4
    mov edi,eax
    add edi,processes

    mov esi,blank
    mov ecx,12
    cld
    rep movsb

 mov ecx,[cpt1]
 loop clear_list
ret


; DATA AREA
first  dd 0

xstart dd 0
xsize  dd 0
ystart dd 0
ysize  dd 20
nbrbtn dd 0
run_app dd 0
btnxsize dd 80
btnysize dd 20
btnxpos  dd 0
btnypos  dd 0
btnid	 dd 0
firstpos dd 0
cpt dd 0
cpt1 dd 0
cpt2 dd 0
nbrproc dd 0
f1 db '<'
f2 db '>'

blank db '            '
processes:
;              4octets + 12 octets
dd 0
db '            '    ;+ 32     + 36
dd 0
db '            '    ;+ 48     + 52
dd 0
db '            '    ;+ 64     + 68
dd 0
db '            '    ;+ 80     + 84
dd 0
db '            '    ;+ 96     +100
dd 0
db '            '    ;+112     +116
dd 0
db '            '    ;+128     +132
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
dd 0
db '            '    ;+144     +148
process_table: times(1024) db 0
I_END:




